#version 120

//inputs from code
	varying vec2 vTexCoord;

	uniform vec4 lightPos;
	uniform vec4 lightLookat;

	uniform vec4 LightColor;
	uniform vec4 ShadowColor;

	uniform vec3 shipPos;
	uniform int Time;
	

//outputs to fragment shader
	varying vec4 lightNormal;
	
	varying float lightPower;
	varying vec3 lightColor;
	
	varying vec3 shadCol;
	
	varying float bgPower;
	varying float bgXPos;



void main(){
	vTexCoord = gl_MultiTexCoord0.xy;

	//pass the proper vertex info to the gpu
		gl_Position = ftransform();

	//this is the light normal
		lightNormal = normalize( lightPos - lightLookat );
		
		lightPower = LightColor.a;
		lightColor = LightColor.rgb;
		
		shadCol = ShadowColor.rgb;
		
		bgPower = clamp(1.0-(shipPos.y / 50.0), 0.0, 0.5);
		bgXPos = shipPos.z / 30.0;
		
		//pass any color info
//		gl_FrontColor = gl_Color;
}