#version 120


//inputs from the code
	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	
	

//outputs To fragment shader
	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;

	// Used for shadow lookup
		varying vec4 ShadowCoord;

		varying vec4 lightNormal;


		varying vec4 texCoord;
	
		varying float isLight;
		varying float isGlass;
		varying float isFauxLight;
	
		varying float materialShine;




void main(){
	// setup the shadow
		ShadowCoord = gl_TextureMatrix[7] * gl_Vertex;

	//this is the untransformed vertex (not rotated or moved, etc)
		vertexRaw = gl_Vertex;

	// Transforming The Vertex
		gl_Position = ftransform();
		vertexPos = gl_ModelViewMatrix * vertexRaw;

	//get the actual vertx depth
		vertexDepth = gl_ModelViewProjectionMatrix * gl_Vertex;

	//get the corrected vertex normal
		vertexNormal = normalize( vec4(gl_Normal.xyz, 1) );

	//this is the light normal
		lightNormal = normalize( lightPos - lightLookat );



	// get the hidden texture coord data
	// get the texture coords
		texCoord = gl_MultiTexCoord0;
	//strip the hidden data	
		int data1 = int(texCoord.z);
	//transform the data
		isLight = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isGlass = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isFauxLight = mod(float(data1), 2.0);

		data1 = data1 - int(isFauxLight);
		data1 = data1 / 2;
/*
	// get the hidden texture coords
		texCoord = gl_MultiTexCoord0;
	//strip the hidden data	
		int data1 = int(texCoord.x);
		int data2 = int(texCoord.y);
		texCoord.x -= float(data1);
		texCoord.y -= float(data2);
	//transform the data
		isLight = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isGlass = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isFauxLight = mod(float(data1), 2.0);
*/

		float matR = mod(float(data1), 10.0);
		float matS = int(float(data1) / 10.0);
		materialShine = (matS + (matR * 10.0));
		if (isFauxLight > 0.0) materialShine += 100;
		materialShine /= 100.0;



	//output color
		gl_FrontColor =  gl_Color;
}
