
#version 120

//this is needed For bitwise operations
#extension GL_EXT_gpu_shader4 : enable

//internal constants
	const float shadowBias = 0.0003;


//inputs from code
	uniform sampler2D fbotex0;
	uniform sampler2D fbotex1;
	uniform sampler2D fbotex2;
	uniform sampler2D fbotex3;
	uniform sampler2D fbotex4;
	uniform sampler2D def0;

	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	uniform vec4 lightColor;

	// this is the light shadow map
	uniform sampler2D ShadowMap;

	uniform vec2 screenRes;


//inputs from vertex shader
	varying vec4 ShadowCoord;

	varying vec4 texCoord;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;

	varying vec4 vertexDepth;
	
	varying vec2 fake_Center;
	varying vec2 fake_FragCoord;
	varying float fake_LightSize;
	
	varying vec4 lightNormal;
	
	varying float isLight;
	varying float isGlass;
	varying float isFauxLight;

	varying float materialReflect;
	varying float materialShine;


//global variables
	vec3 diffuse;




float packColor(vec3 color)
{
	int r = int(color.r * 3.0);
	int g = int(color.g * 3.0) << 2;
	int b = int(color.b * 3.0) << 4;
	
	return (r+g+b) / 256.0;
}


vec3 unpackColor(float col)
{
	int cl = int(col * 256.0);
	int r = 0;
	int g = 0;
	int b = 0;
	
	if (cl > 31.0){
		r = 128;
		cl -= 32;
	}
	if (cl > 15.0){
		r += 64;
		cl -= 16;
	}

	if (cl > 7.0){
		g = 128;
		cl -= 8;
	}
	if (cl > 3.0){
		g += 64;
		cl -= 4;
	}
	
	if (cl > 1.0){
		b = 128;
		cl -= 2;
	}
	if (cl > 0.0){
		b += 64;
	}
	
	
	return vec3(r / 256.0, g / 256.0, b / 256.0);
}



void main()
{
	//channel 0 is the RGB
		vec2 fake_screenCoord = vec2(gl_FragCoord.x / screenRes.x, gl_FragCoord.y / screenRes.y);
		vec4 deferredRGB = texture2D(fbotex0, fake_screenCoord);
		diffuse = vec3(deferredRGB.rgb);


	//actual depth of fragment
	float depth = (1.0/(vertexDepth.z/35.0));
//	diffuse = vec3(depth, 0.0, 0.0);

	//depth of fbo screen
	vec4 deferredDepth = texture2D(fbotex1, fake_screenCoord);
	float fbodepth = deferredDepth.x;

		
//		diffuse = vec3(fake_screenCoord.x, fake_screenCoord.y, 0.0);
//		diffuse = vec3(fake_screenCoord.y, 0.0, 0.0);
		
//		diffuse = vec3(1.0, 0.0, 0.0);

		//get the light decay
		float len = (1.0-(length(fake_FragCoord - fake_Center) * fake_LightSize)) * gl_Color.a;
//		float len = (length(fake_FragCoord - fake_Center)/fake_LightSize) * gl_Color.a;
//		vec3 light = gl_Color.rgb * len;//(1.0-(len * fake_LightSize));

		vec3 light = gl_Color.rgb * (len * 3);

		if (depth > fbodepth){
			gl_FragColor = vec4(light, 1.0);
		}


/*
	vec4 color = gl_Color;

//	float depth = (1.0/(vertexDepth.z/35.0));

	//lighting	
		float alpha = color.a;

		//this is the actual screen xy
//			gl_FragColor = vec4(fake_FragCoord.xy * 0.3, 0.0, 1.0);

		//note sure, but this is the screen location of the center xy
//			gl_FragColor = vec4(fake_Center.xy * 0.3, 0.0, 1.0);

		// THIS IS IT - the center of each object
//			gl_FragColor = vec4(fake_FragCoord.xy - fake_Center.xy, 0.0, 1.0);

		//get the light decay
			float len = length(fake_FragCoord - fake_Center);
		
		//test decay
//			gl_FragColor = vec4(1.0-(len * fake_LightSize), 0.0, 0.0, 1.0);

		//actual light
			gl_FragColor = vec4(depth, (1.0-(len * fake_LightSize)) * alpha, packColor(gl_Color.rgb), 1.0);
*/
}


/*
#version 120

//this is needed For bitwise operations
#extension GL_EXT_gpu_shader4 : enable


//inputs from code
	uniform sampler2D fbotex0;
	uniform sampler2D fbotex1;
	uniform sampler2D fbotex2;
	uniform sampler2D fbotex3;
	uniform sampler2D fbotex4;
	uniform sampler2D def0;
	
//inputs from vertex shader
	varying vec2 vTexCoord;

	varying vec4 lightNormal;

	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	uniform vec4 LightColor;

	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 VertexNormal;

//global variables
	vec3 diffuse;


void main(void){
	
	//channel 0 is the RGB
//		vec4 deferred = texture2D(fbotex0, vec2(vTexCoord));
//		float alpha = deferred.a;
//		diffuse = deferred.rgb;

	//chanel 1 is the depth, shadow, lightEmit
//		vec4 deferred = texture2D(fbotex1, vec2(vTexCoord));
//		float depth = deferred.r;

	float depth = (1.0/(vertexDepth.z/35.0));
	diffuse = vec3(depth, 0.0, 0.0);
//	if (depth > 0.5) depth = 0.0;

//	gl_FragColor = vec4(depth, 0.0, 0.0, 1.0);
	
	gl_FragColor = vec4(diffuse, 1.0);

//	gl_FragColor = vec4(gl_Color.xyz, 1.0);	

//	gl_FragColor = gl_Color;	
	
}

*/