
#version 120


//inputs from code
	uniform vec4 lightPos;
	uniform vec4 lightLookat;

	uniform float ambiantLight;
	
	
//outputs
	// Used for shadow lookup
	varying vec4 ShadowCoord;

	varying vec4 texCoord;

	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;
	
//	varying vec2 fake_screenCoord;

	varying vec2 fake_Center;
	varying vec2 fake_FragCoord;
	varying float fake_LightSize;
	
	varying vec4 lightNormal;

	varying float isLight;
	varying float isGlass;
	varying float isFauxLight;
	
	varying float materialReflect;
	varying float materialShine;


void main()
{
	ShadowCoord = gl_TextureMatrix[7] * gl_Vertex;
	
	
	// get the texture coords
		texCoord = gl_MultiTexCoord0;

	// get the hidden texture coord data
//		texCoord = gl_MultiTexCoord1;
	//strip the hidden data	
		int data1 = int(texCoord.z);
	//transform the data
		isLight = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isGlass = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isFauxLight = mod(float(data1), 2.0);

		data1 = data1 - int(isFauxLight);
		data1 = data1 / 2;
/*
	// get the hidden texture coords
		texCoord = gl_MultiTexCoord0;
	//strip the hidden data	
		int data1 = int(texCoord.x);
		int data2 = int(texCoord.y);
		texCoord.x -= float(data1);
		texCoord.y -= float(data2);
	//transform the data
		isLight = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isGlass = mod(float(data1), 2.0);
		
		data1 = data1 - int(isLight);
		data1 = data1 / 2;
		isFauxLight = mod(float(data1), 2.0);
*/
		materialReflect = (mod(float(data1), 10.0)) * 0.1;
		materialShine = int(float(data1) / 10.0) * 0.1;
			
		

	//this is the untransformed vertex (not rotated or moved, etc)
		vertexRaw = gl_Vertex;

	//this is the light normal
		lightNormal = normalize( lightPos - lightLookat );


	//pass the proper vertex info to the gpu
		gl_Position = ftransform();
		vertexPos = gl_ModelViewMatrix * vertexRaw;


	//get the corrected vertex normal
		vertexNormal = normalize( vec4(gl_Normal.xyz, 1) );

//		fake_screenCoord = gl_FragCoord.xy;
		
		fake_Center = (gl_ModelViewMatrix * vec4(gl_Normal.xyz, 0.0)).xy;
		fake_FragCoord = (gl_ModelViewMatrix * vec4(gl_Vertex.xyz, 0.0)).xy;
		fake_LightSize = 2.0 / texCoord.a;

	//get the actual vertx depth
		vertexDepth = gl_ModelViewProjectionMatrix * gl_Vertex;

	//raw color
		gl_FrontColor = gl_Color + ambiantLight;
}


/*
#version 120

//inputs from the code
	varying vec2 vTexCoord;

	uniform vec4 lightPos;
	uniform vec4 lightLookat;
	
	

//outputs To fragment shader
	varying vec4 vertexDepth;

	varying vec4 vertexPos;
	varying vec4 vertexRaw;
	varying vec4 vertexNormal;

	// Used for shadow lookup
		varying vec4 ShadowCoord;

		varying vec4 lightNormal;




void main(){
	vTexCoord = gl_MultiTexCoord0.xy;

	//this is the untransformed vertex (not rotated or moved, etc)
		vertexRaw = gl_Vertex;

	// Transforming The Vertex
		gl_Position = ftransform();
		vertexPos = gl_ModelViewMatrix * vertexRaw;

	//get the actual vertx depth
		vertexDepth = gl_ModelViewProjectionMatrix * gl_Vertex;

	//get the corrected vertex normal
		vertexNormal = normalize( vec4(gl_Normal.xyz, 1) );

	//this is the light normal
		lightNormal = normalize( lightPos - lightLookat );



	//output color
		gl_FrontColor =  gl_Color;
}
*/